-- Author      : admin
-- Create Date : 10/13/2019 2:28:25 PM

do
    local a = newArray();
    
    local b = a.forEach();

    assert(b == nil, 'expect b to be nil');
end

do
    local a = newArray('1');
    
    local b = a.forEach(function(v, i, arr)
        assert(type(v) == 'string');
        assert(type(i) == 'number');
        assert(type(arr) == 'table');
        assert(arr == a);
    end);

    assert(b == nil, 'expect b to be nil');
end

do
    local a = newArray(1,2,3,4,5,6,7,8,9);
    local i = 0;

    assert(i == 0, 'expect i to be 0');

    a.forEach(function() 
        i = i + 1; 
    end);

    assert(i == 9, 'expect i to be 9');
end