-- Author      : admin
-- Create Date : 10/13/2019 2:27:27 PM

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.filter();

    assert(#b == 0, 'expect b to contain not items');
end

do
    local a = newArray('1', '2', '3', '4', '5', '6', '7', '8', '9');
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.filter(function(v, i, arr)
        assert(type(v) == 'string');
        assert(type(i) == 'number');
        assert(type(arr) == 'table');
        assert(arr == a);

        -- return implicity false
    end);

    assert(#b == 0, 'expect b to contain not items');
end

do
    local a = newArray(1, 2, 3, 4, 5, 6, 7, 8, 9);
    
    assert(9 == #a, 'c should contain nine items');

    local b = a.filter(function(v)
        return v > 3 and v < 7;
    end);

    assert(#b == 3, 'expect b to contain three items');
end