-- Author      : admin
-- Create Date : 10/13/2019 2:30:33 PM

do
    local a = newArray();

    local b = a.sort();

    assert(#a == 0, 'expect #a to be 0');
    assert(b == a, 'expect b to be a');
end

do
    local a = newArray(1,9,2,8,3,7,4,6,5);

    local b = a.sort();

    assert(#a == 9, 'expect #a to be 0');
    assert(b == a, 'expect b to be a');
    assert(a[1] == 1);
    assert(a[2] == 2);
    assert(a[3] == 3);
    assert(a[4] == 4);
    assert(a[5] == 5);
    assert(a[6] == 6);
    assert(a[7] == 7);
    assert(a[8] == 8);
    assert(a[9] == 9);
end

do
    local a = newArray(1,9,2,8,3,7,4,6,5);

    local b = a.sort(function(b , c)
        return (#a - b) < (#a - c)
    end);

    assert(#a == 9, 'expect #a to be 0');
    assert(b == a, 'expect b to be a');
    assert(a[1] == 9);
    assert(a[2] == 8);
    assert(a[3] == 7);
    assert(a[4] == 6);
    assert(a[5] == 5);
    assert(a[6] == 4);
    assert(a[7] == 3);
    assert(a[8] == 2);
    assert(a[9] == 1);
end
